unit Analizator;
interface
uses Windows, SysUtils, stdctrls, classes;

type
    TTabS = array of string;
    TCharSet = set of char;

    Zmienna = record
       nazwa: string;
       typ: char;
       wartosc: Variant;
    end;
    Blad = record
       typ_bledu: string;
    end;
    TZmienne = array of Zmienna;
    TBledy = array of Blad;
    TAnaliza = class
    dolny: ^TMemo;
    gorny: ^TMemo;
    KodProgramu: ^TStrings;
  private
      kod: String;
      tabela_bledow: TBledy;
      tabela_slow: TTabS;
      tabela_zmiennych: TZmienne;
      tabela_instrukcji: TTabS;
      function podziel_na_slowa(tekst: String): integer;
      function SprawdzNazwa(slowo: String): boolean;
      function TworzZmienna(nz: String; typ: String; war: String): zmienna;
      function czy_juz_istnieje(tab: TTabS; tresc: String): boolean;
      function czy_typ(slowo: String): String;
      function czy_slowo_kluczowe(slowo: String): String;
      procedure WstawPola(var ile: integer; var tab: TTabS; tresc: string);
      function RozpoznajTyp(war: String): String;
      function daj_index_zmiennej(zm: string): Zmienna;
      function zamien_operator(op :String):String;
      procedure WstawBladDoTabeli(var ile: integer;  tresc: string);
      function czy_kod_ok(): boolean;
      procedure MaleZnaki();
      procedure tworz_tab_instrukcji(t_slow : array of String; var ile:integer);
      function czy_typy_ok(): boolean;
      function PrzekazTabeleInstrukcji: TTabS;
      function PrzekazTabeleZmiennych: TZmienne;
      function PrzekazTabeleBledow: TBledy;
      function PrzekazTabeleSlow: TTabS;
  public
      procedure Analizuj(Memo: TMemo; tekst: TStrings; Info:TMemo);
      function tworz_zmienne(): integer;

  end;

var a : TAnaliza;

implementation

uses Executor;


function TAnaliza.SprawdzNazwa(slowo: String): boolean;
   begin
      if slowo[1] in ['a'..'z']then
      SprawdzNazwa:=true  else SprawdzNazwa:=false;
   end;



procedure TAnaliza.Analizuj(Memo: TMemo; tekst: TStrings; Info:TMemo);
   var i,ile: integer;

       b: Blad;
       d: TExecutor;

   begin
      try
      dolny:=@Memo;
      KodProgramu:=@tekst;
      gorny:=@Info;
      ile:=0;
      dolny^.Lines.Clear;
      gorny^.Lines.Append('Analizator dzieli kod programu na slowa');
      podziel_na_slowa(KodProgramu^.Text);
      gorny^.SelStart:=length(dolny^.Text);
      gorny^.lines.Add('');
      for i:=0 to length(tabela_slow)-1 do
                        begin
                          gorny^.selText:=(tabela_slow[i]+'| ');
                        end;
      gorny^.Lines.Append('');
      gorny^.Lines.Append('Analizator zamienia wszystkie slowa na male znaki');
      MaleZnaki();
      gorny^.Lines.Append('zamieniono.');
        gorny^.Lines.Append(' ');
      gorny^.Lines.Append('Analizator sprawdza poprawnosc kodu');
      if czy_kod_ok() then      // blad!
      for i:=0 to length(tabela_bledow)-1 do
      begin
         b:=PrzekazTabeleBledow[i];
         dolny^.Lines.Append(b.typ_bledu);

      end;
      if (length(tabela_bledow)-1)=-1 then
      begin
     gorny^.Lines.Append('Nie znaleziono bledow.');
       gorny^.Lines.Append(' ');
     gorny^.Lines.Append('Analizator wyszukuje deklaracje zmiennych i umieszcza je w tabeli zmiennych');
             gorny^.Lines.Append(' ');

              tworz_zmienne();
          for i:=0 to length(tabela_zmiennych)-1 do
             gorny^.Lines.Add('zmienna: '+tabela_zmiennych[i].nazwa+' typ: '+tabela_zmiennych[i].typ);

               gorny^.Lines.Append(' ');
          gorny^.Lines.Append('Analizator sprawdza zgodnosc typow w operacjach ');
          if czy_typy_ok() then
          begin
             for i:=0 to length(tabela_bledow)-1 do
             begin
                b:=PrzekazTabeleBledow[i];
                dolny^.Lines.Append(b.typ_bledu);
             end;
             dolny^.Lines.Append(#13#10+'Liczba bdw: '+IntToStr(length(tabela_bledow)))
          end else
          begin
          gorny^.Lines.Append('Nie znaleziono bledow');
          gorny^.Lines.Append('');
          gorny^.Lines.Append('Analizator tworzy tabele instrukcji:');
                   tworz_tab_instrukcji(PrzekazTabeleSlow,ile);
          gorny^.Lines.Append('');
          for i:=0 to length(tabela_instrukcji)-1 do
                        begin

                                gorny^.selText:=(tabela_instrukcji[i]+'| ');
                        end;
                          gorny^.Lines.Append(' ');
           gorny^.Lines.Append('Analizator wykonuje metode Exec');
             d:=TExecutor.Create;
             d.Uruchom(Memo,PrzekazTabeleZmiennych,PrzekazTabeleInstrukcji);
          end;
      end else
          dolny^.Lines.Append(#13#10+'Liczba bdw: '+IntToStr(length(PrzekazTabeleBledow)));
      except
      on E: Exception do
      begin
         dolny^.Lines.Append('Bd 111. W kodzie programu jest bd nie wykrywalny przez interpreter. ');
         dolny^.Lines.Append(#13#10+'Liczba bdw: 1');
      end;
      end;

   end;

procedure TAnaliza.MaleZnaki();
   var i: integer;
   begin
      for i:=0 to length(tabela_slow)-1 do
      begin
         if tabela_slow[i][1]<>#39 then
            tabela_slow[i]:=AnsiLowerCase(tabela_slow[i]);
      end;
   end;


function TAnaliza.PrzekazTabeleBledow: TBledy;
   begin
      Result:=tabela_bledow;
   end;


function TAnaliza.PrzekazTabeleInstrukcji: TTabS;
   begin
      Result:=tabela_instrukcji;
   end;


function TAnaliza.PrzekazTabeleZmiennych: TZmienne;
   begin
      Result:=tabela_zmiennych;
   end;


function TAnaliza.PrzekazTabeleSlow: TTabS;
   begin
      Result:=tabela_slow;
   end;

function TAnaliza.czy_slowo_kluczowe(slowo: String): string;
   var
       zwrot: string;
   begin
      zwrot:='';
         if slowo='program'  then zwrot:='program';
         if slowo='var'  then zwrot:='var';
         if slowo='begin'  then zwrot:='begin';
         if slowo='end'  then zwrot:='end';
         if slowo='while'  then zwrot:='while';
         if slowo='if'  then zwrot:='if';
         if slowo='do'  then zwrot:='do';
         if slowo='then'  then zwrot:='then';
         if slowo='write'  then zwrot:='write';
         if slowo='writeln'  then zwrot:='writeln';
         if slowo='read'  then zwrot:='read';
         if slowo='readln'  then zwrot:='readln';
         if slowo='else'  then zwrot:='else';
      Result:=zwrot;
   end;

function TAnaliza.czy_typ(slowo: String): string;
   var
       zwrot: string;
   begin
      zwrot:='';

      if slowo='integer' then zwrot:='integer';
      if slowo='real' then zwrot:='real';

      if slowo='boolean' then zwrot:='boolean';
      Result:=zwrot;
   end;

function TAnaliza.zamien_operator(op :String):String;
   begin
     if op='+' then zamien_operator:='dodaj';
      if op='-' then zamien_operator:='odejmij';
      if op='*' then zamien_operator:='pomnoz';
      if op='/' then zamien_operator:='podziel';
      if op='=' then zamien_operator:='rowny';
      if op='<' then zamien_operator:='mniejszy';
      if op='>' then zamien_operator:='wiekszy';
      if op='<>' then zamien_operator:='rozny';
      if op='<=' then zamien_operator:='mniejszy_rowny';
      if op='>=' then zamien_operator:='wiekszy_rowny';

   end;


 procedure TAnaliza.tworz_tab_instrukcji(t_slow : array of String; var ile:integer);
  var pom_slowa :array of String;
      i,liczB,pom_s:integer;
      konSlowo : string[20];
  begin
     i:=0;
     if ile=0 then while t_slow[i]<>'begin' do inc(i);//przechodzenie do poczatku glownego bloku
     if t_slow[i]='begin' then begin
        setLength(tabela_instrukcji,ile+1);
        tabela_instrukcji[ile]:='pocz_begin';
        inc(ile);
     end;
     while i<length(t_slow)-1 do begin
        inc(i);
        if t_slow[i]=':=' then begin
           setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:='podstaw';
           inc(ile);
           setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=t_slow[i-1];
           inc(ile);inc(i);
           if t_slow[i+1]<>';' then begin
              setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=zamien_operator(t_slow[i+1]);//t_slow[i+1];
              inc(ile);
              setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=t_slow[i];
              inc(ile);inc(i);inc(i);
              setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=t_slow[i];
              inc(ile);inc(i);
           end else begin
                  setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=t_slow[i];
                  inc(ile);inc(i);
               end;
           setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:='kon_podstaw';
           inc(ile);
        end;
        
        if (t_slow[i]='write')or(t_slow[i]='writeln') then begin
           //kontrola ktora to jest konkretnie instrukcj i ustalenie odpowiedniego slowa koncowego
           if(t_slow[i]='write') then konSlowo:='kon_wypisz'
           else konSlowo:='kon_wypiszln';
           setLength(tabela_instrukcji,ile+1);
           if(t_slow[i]='write') then tabela_instrukcji[ile]:='wypisz'
           else tabela_instrukcji[ile]:='wypiszln';
           inc(ile);inc(i);inc(i);
           while t_slow[i]<>')' do begin
              setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=t_slow[i];
              inc(ile);inc(i);
           end;
           setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=konSlowo;
              inc(ile);
        end;
        if (t_slow[i]='read')or(t_slow[i]='readln') then begin
           //kontrola ktora to jest konkretnie instrukcj i ustalenie odpowiedniego slowa koncowego
           if(t_slow[i]='read') then konSlowo:='kon_wczytaj'
           else konSlowo:='kon_wczytajln';

           setLength(tabela_instrukcji,ile+1);
           if(t_slow[i]='read') then tabela_instrukcji[ile]:='wczytaj'
           else tabela_instrukcji[ile]:='wczytajln';
           inc(ile);inc(i);inc(i);
           while t_slow[i]<>')' do begin
              setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=t_slow[i];
              inc(ile);inc(i);
           end;
           setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=konSlowo;
              inc(ile);
        end;
        if (t_slow[i]='if') or (t_slow[i]='while') then begin
           //kontrola ktora to jest konkretnie instrukcj i ustalenie odpowiednich slowo poczatkowego i koncowego
           if t_slow[i]='if' then begin
              setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:='jesli';
              konSlowo:='kon_jesli';
           end else begin
                  setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:='dopoki';
                  konSlowo:='kon_dopoki';
               end;
           inc(ile);inc(i);inc(i);
           setLength(tabela_instrukcji,ile+1);
           tabela_instrukcji[ile]:=zamien_operator(t_slow[i]);
           inc(ile);
           setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=t_slow[i-1];
           inc(ile);
           setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=t_slow[i+1];
           inc(ile);i:=i+2;
           liczB:=0;pom_s:=0;
           
                //zapetlenie
           
           while (liczB<>0) or (t_slow[i]<>';') do begin
              if t_slow[i]='begin' then inc(liczB);
              if t_slow[i]='end' then dec(liczB);
              //inc(i);
              setLength(pom_slowa,pom_s+1);pom_slowa[pom_s]:=t_slow[i];
              inc(pom_s);
              inc(i);
           end;
           setLength(pom_slowa,pom_s+1);pom_slowa[pom_s]:=';';//inc(pom_s);
           tworz_tab_instrukcji(pom_slowa,ile);
           setLength(tabela_instrukcji,ile+1);tabela_instrukcji[ile]:=konSlowo;
           inc(ile);
        end;
     end;
     if ((t_slow[i-2]='end')and(t_slow[i-1]='.')) then
     begin
        setLength(tabela_instrukcji,ile+1);
        tabela_instrukcji[ile]:='kon_begin';
        inc(ile);
     end;
  end;


procedure TAnaliza.WstawBladDoTabeli(var ile: integer; tresc: string);
  var wb: Blad;
  begin
     inc(ile);
     setLength(tabela_bledow,ile);

     wb.typ_bledu:=tresc;
     tabela_bledow[ile-1]:=wb;
  end;


procedure TAnaliza.WstawPola(var ile: integer; var tab: TTabS; tresc: string);
  begin
     inc(ile);
     setLength(tab,ile);
     tab[ile-1]:=tresc;
  end;


function TAnaliza.czy_juz_istnieje(tab: TTabS; tresc: String): boolean;
  var i: integer;
      tak: boolean;
  begin
     tak:=false;
        if (tresc='program') or (tresc='var') or (tresc='if') or (tresc='then')
        or (tresc='while') or (tresc='do') or (tresc='begin') or (tresc='end') or (tresc='write')
        or (tresc='writeln') or (tresc='read') or (tresc='readln') or (tresc='else')
        then
        begin
           tak:=true;
        end;

     if (tresc='integer') or (tresc='real')  or (tresc='boolean')
        then
        begin
           tak:=true;
        end;

     if not tak then
     for i:=0 to length(tab)-1 do
     begin
        if tab[i]=tresc then
        begin
           tak:=true; break;
        end;
     end;
     Result:=tak;
  end;

function TAnaliza.czy_kod_ok(): boolean;
   var i,ile,ilezmiennych: integer;
       ilosc_begin,ilosc_end: integer;
       sklucz, klucz: string;
       tab: TTabS;
   begin
       ile:=0;  ilezmiennych:=0;
      ilosc_begin:=0; ilosc_end:=0;
      klucz:=''; i:=0;
      while i<=length(tabela_slow)-1 do
      begin
         if tabela_slow[i]=#13 then
         begin

            inc(i);
         end else
         begin
            sklucz:=czy_slowo_kluczowe(tabela_slow[i]);
            if sklucz='' then
            begin
               if (tabela_slow[i+1]=':') or (tabela_slow[i+1]='=')
                  or (tabela_slow[i+1]='<') or (tabela_slow[i+1]='>')
                  or (tabela_slow[i+1]=',') or (tabela_slow[i+1]=':=')
                  or (tabela_slow[i+1]='>=') or (tabela_slow[i+1]='<=')
                  or (tabela_slow[i+1]='<>') then
               begin
                  if klucz='var' then
                  begin
                     {sprawdzanie nazwy}
                     if not SprawdzNazwa(tabela_slow[i]) then
                      WstawBladDoTabeli(ile, 'Bdna nazwa "'+tabela_slow[i]+'"');
                     if not czy_juz_istnieje(tab, tabela_slow[i]) then
                          WstawPola(ilezmiennych,tab,tabela_slow[i]) else
                     begin
                        WstawBladDoTabeli(ile, 'program gwny uywa ju tej nazwy "'+tabela_slow[i]+'".');
                     end;
                  end;
                  if (klucz='begin') and (tabela_slow[i+1]=':=') then
                  begin
                     inc(i);
                     while (i<=length(tabela_slow)-1) do
                     begin
                        if tabela_slow[i+2][1] in ['+','-','*','/'] then
                        begin
                           i:=i+2;
                           if tabela_slow[i+2]<>';' then
                           begin
                              i:=i+1;
                              WstawBladDoTabeli(ile, 'Brak ";" na kocu wyraenia.');
                              break;
                           end else i:=i+2;
                        end else
                        if tabela_slow[i+2]<>';' then
                        begin
                           i:=i+1;
                           WstawBladDoTabeli(ile, 'Brak ";" na kocu wyraenia.');
                           break;
                        end else i:=i+2;
                        if tabela_slow[i]=#13 then
                        begin

                           WstawBladDoTabeli(ile, 'Brak ";" na kocu wyraenia.');
                           break;
                        end;
                        if tabela_slow[i]=';' then break;
                        inc(i);
                     end;
                  end;
                  if (klucz='var') and (tabela_slow[i+1]=':') then
                  begin
                     if czy_typ(tabela_slow[i+2])='' then
                     begin
                        WstawBladDoTabeli(ile, 'Bdny typ "'+tabela_slow[i+2]+'"');
                        while (i<=length(tabela_slow)-1) do
                        begin
                           if tabela_slow[i]=#13 then begin  break; end;
                           if tabela_slow[i]=';' then break;
                           inc(i);
                        end;
                     end else
                     begin
                        while (i<=length(tabela_slow)-1) do
                        begin
                           if tabela_slow[i]=#13 then
                           begin

                              WstawBladDoTabeli(ile, 'Brak ";" na kocu wyraenia.');
                              break;
                           end;
                           if tabela_slow[i]=';' then break;
                           inc(i);
                        end;
                     end;
                  end else
                  begin
                     if (klucz='var') and (tabela_slow[i+1]<>':') and (tabela_slow[i+1]<>',') then
                     begin
                        WstawBladDoTabeli(ile, 'W tym miejscu powinien by ":", a jest "'+tabela_slow[i+1]+'"');
                        if czy_typ(tabela_slow[i+2])='' then
                        begin
                           WstawBladDoTabeli(ile, 'Bdny typ "'+tabela_slow[i+2]+'"');
                           while (i<=length(tabela_slow)-1) do
                           begin
                              if tabela_slow[i]=#13 then begin  break; end;
                              if tabela_slow[i]=';' then break;
                              inc(i);
                           end;
                        end else
                        begin
                           while (i<=length(tabela_slow)-1) do
                           begin
                              if tabela_slow[i]=#13 then
                              begin

                                 WstawBladDoTabeli(ile, 'Brak ";" na kocu wyraenia.');
                                 break;
                              end;
                              if tabela_slow[i]=';' then break;
                              inc(i);
                           end;
                        end;
                     end;
                  end;

                  if (tabela_slow[i+1]='=') or (tabela_slow[i+1]='<')
                     or (tabela_slow[i+1]='>') or (tabela_slow[i+1]='>=')
                     or (tabela_slow[i+1]='<=') or (tabela_slow[i+1]='<>') then
                  begin
                     i:=i+2;
                  end;
               if tabela_slow[i+1]=',' then
                  begin
                     inc(i);
                  end;
               end else
               begin
                  WstawBladDoTabeli(ile, 'Bdna klauzula "'+tabela_slow[i]+'"');
               end;
            end else   //znlazl slowo kluczowe!
            begin
               if sklucz<>'' then
               begin
                  if (sklucz='if') or (sklucz='while') then
                  begin
                     if not (tabela_slow[i+2][1] in ['<','>','=']) then
                        WstawBladDoTabeli(ile, 'Bdna operacja porwnania "'+tabela_slow[i+2]+'"');
                     if (sklucz='if') and (tabela_slow[i+4]<>'then') then
                        WstawBladDoTabeli(ile, 'Bdna klauzula "'+tabela_slow[i+4]+'"');
                     if (sklucz='while') and (tabela_slow[i+4]<>'do') then
                        WstawBladDoTabeli(ile, 'Bdna klauzula "'+tabela_slow[i+4]+'"');
                     i := i + 3;
                  end;
                  if sklucz='program' then
                  begin
                     WstawPola(ilezmiennych,tab,tabela_slow[i+1]);
                     while (i<=length(tabela_slow)-1) do
                     begin
                        if tabela_slow[i]=#13 then
                        begin
                           WstawBladDoTabeli(ile, 'Brak ";" na kocu wyraenia.');
                           break;
                        end;
                        if tabela_slow[i]=';' then break;
                        inc(i);
                     end;
                     i:=i+1;
                  end;
                  if sklucz='end' then
                  begin
                     inc(ilosc_end);
                     if (tabela_slow[i+1]<>';') and (ilosc_end<ilosc_begin) then
                        WstawBladDoTabeli(ile, 'Brak ";" na kocu bloku. ');
                     inc(i);
                  end;
                  if sklucz='begin' then inc(ilosc_begin);
                  if (sklucz='var') or (sklucz='begin')
                      then klucz:=sklucz;
                  if (sklucz='readln') or (sklucz='read')
                     or (sklucz='write') or (sklucz='writeln')
                     then
                  begin
                     if tabela_slow[i+1]<>'(' then
                     begin
                        WstawBladDoTabeli(ile, 'Brak parametrw i nawiasw. ');
                     end else
                     begin
                        inc(i);
                        while tabela_slow[i]<>')' do
                        begin
                           if (tabela_slow[i]=';') or (tabela_slow[i]=#13) then
                           begin
                              WstawBladDoTabeli(ile, 'Brak nawiasu zamykajcego ")".');
                              dec(i);
                              break;
                           end;
                           inc(i);
                        end;
                     end;
                     inc(i);
                     if tabela_slow[i]<>';' then
                     begin
                        WstawBladDoTabeli(ile, 'Brak ";" na kocu wyraenia.');
                        dec(i);
                     end;
                  end;
               end else
               while (i<=length(tabela_slow)-1) do
               begin
                  if tabela_slow[i]=#13 then begin  break; end
                  else break;
                  if tabela_slow[i]=';' then break;
                  inc(i);
               end;
            end;
            inc(i);
         end;
      end;
      if (ilosc_begin=0) and (ilosc_end=0) then WstawBladDoTabeli(ile, 'Brak bloku gwnego "begin end."');
      if ilosc_begin<>ilosc_end then WstawBladDoTabeli(ile, 'Stosunek begin/end <> 1');
      for i:=length(tabela_slow)-1 downto 0 do
      begin

         if tabela_slow[i]='end' then
         begin
            if tabela_slow[i+1]<>'.' then
               WstawBladDoTabeli(ile, 'Bdny znak koca "'+tabela_slow[i+1]+'" -> "."');
            break;
         end;
      end;
      if ile=0 then Result:=false else Result:=true;
   end;

function TAnaliza.daj_index_zmiennej(zm: string): Zmienna;
   var i: integer;
       z: Zmienna;
   begin
      for i:=0 to length(tabela_zmiennych)-1 do
         if zm=tabela_zmiennych[i].nazwa then
         begin
            z:=tabela_zmiennych[i];
            break;
         end;
      Result:=z;
   end;

function TAnaliza.czy_typy_ok(): boolean;
   var i,ile: integer;
       sklucz: string;
       d,f,g: char;
       z: Zmienna;
   begin
      i:=0; ile:=length(tabela_bledow);
      while i<=length(tabela_slow)-1 do
      begin
         if tabela_slow[i]=#13 then
         begin
         end else
         begin
            if tabela_slow[i]='begin' then sklucz:='begin';
            if (tabela_slow[i]='(') and (sklucz='begin') then
            begin
            if (tabela_slow[i-1]='readln') or (tabela_slow[i-1]='read') then
            begin
               inc(i);
                  z:=daj_index_zmiennej(tabela_slow[i]);
                  if z.nazwa='' then
                     WstawBladDoTabeli(ile, 'Ta warto jest niepoprawna "'+tabela_slow[i]+'"');

            end;
            if (tabela_slow[i-1]='write') or (tabela_slow[i-1]='writeln') then
            begin
               inc(i);
               while tabela_slow[i]<>')' do
               begin
                  if (tabela_slow[i]<>',') then
                  begin
                     z:=daj_index_zmiennej(tabela_slow[i]);
                     if (z.nazwa='') and (tabela_slow[i][1]<>#39) //  ciapek (szczeglny przypadek)
                     then
                        WstawBladDoTabeli(ile, 'Ta warto jest niepoprawna "'+tabela_slow[i]+'"');

                  end else
                     if tabela_slow[i-1][1] in ['(',','] then WstawBladDoTabeli(ile, 'Oczekiwano zmiennej lub wartoci "'+tabela_slow[i]+'"');
                  if tabela_slow[i]=')' then break;
                  inc(i);
               end;
            end;
            end;
            if tabela_slow[i]=':=' then
            begin
               if (tabela_slow[i+2][1] in ['-','*','/','+']) and (sklucz='begin') then
               begin

                     z:=daj_index_zmiennej(tabela_slow[i-1]);
                     if z.nazwa='' then
                     begin
                        WstawBladDoTabeli(ile, 'Ta zmienna nie jest zadeklarowana "'+tabela_slow[i-1]+'"');
                     end else d:=z.typ;          // d:=g+f


                  if (RozpoznajTyp(tabela_slow[i+1])='integer') or (RozpoznajTyp(tabela_slow[i+1])='real')
                     or  (RozpoznajTyp(tabela_slow[i+1])='boolean') then
                  begin
                     if RozpoznajTyp(tabela_slow[i+1])='integer' then g:='I';
                     if RozpoznajTyp(tabela_slow[i+1])='real' then g:='R';
                     if RozpoznajTyp(tabela_slow[i+1])='boolean' then g:='B';
                  end else
                     z:=daj_index_zmiennej(tabela_slow[i+1]);
                     if z.nazwa='' then
                     begin
                        WstawBladDoTabeli(ile, 'Ta zmienna nie jest zadeklarowana "'+tabela_slow[i+1]+'"');
                     end else g:=z.typ;             // d:=g+f

                  if (RozpoznajTyp(tabela_slow[i+3])='integer') or (RozpoznajTyp(tabela_slow[i+3])='real')
                     or (RozpoznajTyp(tabela_slow[i+3])='boolean') then
                  begin
                     if RozpoznajTyp(tabela_slow[i+3])='integer' then f:='I';
                     if RozpoznajTyp(tabela_slow[i+3])='real' then f:='R';
                     if RozpoznajTyp(tabela_slow[i+1])='boolean' then g:='B';
                  end else
                     z:=daj_index_zmiennej(tabela_slow[i+3]);
                     if z.nazwa='' then
                     begin
                        WstawBladDoTabeli(ile, 'Ta zmienna nie jest zadeklarowana "'+tabela_slow[i+3]+'"');
                     end else f:=z.typ;                   // d:=g+f

                  case d of
                  'B': if (d=g) and (d=f) then
                       begin
                          if (g='B') and (tabela_slow[i+2][1] in ['-','*','/','+']) then
                          WstawBladDoTabeli(ile, 'Dla tego typu nie jest dopuszczalny operator "'+tabela_slow[i+2]+'"');
                       end else
                       begin
                          WstawBladDoTabeli(ile, 'Typy w tym wyraeniu s nie dopasowane "'+tabela_slow[i-1]+tabela_slow[i]+tabela_slow[i+1]+tabela_slow[i+2]+tabela_slow[i+3]+'"');
                       end;
                  'I': if not ((g=d) and (d=f)) then
                          WstawBladDoTabeli(ile, 'Typy w tym wyraeniu s nie dopasowane "'+tabela_slow[i-1]+tabela_slow[i]+tabela_slow[i+1]+tabela_slow[i+2]+tabela_slow[i+3]+'"');
                  'R': if not ((g='R') or (g='I')) and ((f='R') or (f='I')) then
                          WstawBladDoTabeli(ile, 'Typy w tym wyraeniu s nie dopasowane "'+tabela_slow[i-1]+tabela_slow[i]+tabela_slow[i+1]+tabela_slow[i+2]+tabela_slow[i+3]+'"');
                  end;
               end else
               begin
                  if (tabela_slow[i+2]=';') and (sklucz='begin') then
                  begin
                        z:=daj_index_zmiennej(tabela_slow[i-1]);
                        if z.nazwa='' then
                        begin
                          WstawBladDoTabeli(ile, 'Ta zmienna nie jest zadeklarowana "'+tabela_slow[i-1]+'"');
                        end else
                        begin
                          d:=z.typ;  //d:=g ;
                        end;
                     if (RozpoznajTyp(tabela_slow[i+1])='integer') or (RozpoznajTyp(tabela_slow[i+1])='real')
                        or (RozpoznajTyp(tabela_slow[i+1])='boolean')  then
                     begin
                        if RozpoznajTyp(tabela_slow[i+1])='integer' then g:='I';
                        if RozpoznajTyp(tabela_slow[i+1])='real' then g:='R';
                        if RozpoznajTyp(tabela_slow[i+1])='boolean' then g:='B';
                     end else
                     if 1=1 then
                     begin
                        z:=daj_index_zmiennej(tabela_slow[i+1]);
                        if z.nazwa='' then
                        begin
                           WstawBladDoTabeli(ile, 'Ta zmienna nie jest zadeklarowana "'+tabela_slow[i+1]+'"');
                        end else g:=z.typ;     //d:=g ;
                     end;
                     case d of

                     'B': if (g<>d) then
                          begin
                             WstawBladDoTabeli(ile, 'Typy w tym wyraeniu s nie dopasowane "'+tabela_slow[i-1]+tabela_slow[i]+tabela_slow[i+1]+tabela_slow[i+2]+'"');
                          end;
                     'I': if not (g=d) then
                             WstawBladDoTabeli(ile, 'Typy w tym wyraeniu s nie dopasowane "'+tabela_slow[i-1]+tabela_slow[i]+tabela_slow[i+1]+tabela_slow[i+2]+'"');
                     'R': if not ((g='R') or (g='I')) then
                             WstawBladDoTabeli(ile, 'Typy w tym wyraeniu s nie dopasowane "'+tabela_slow[i-1]+tabela_slow[i]+tabela_slow[i+1]+tabela_slow[i+2]+'"');
                     end;
                  end;
               end;
            end;
            if (tabela_slow[i]='if')
               or (tabela_slow[i]='while') then
            begin
               if (RozpoznajTyp(tabela_slow[i+1])='integer') or (RozpoznajTyp(tabela_slow[i+1])='real')
                  or (RozpoznajTyp(tabela_slow[i+1])='boolean') then
               begin
                  if RozpoznajTyp(tabela_slow[i+1])='integer' then d:='I';
                  if RozpoznajTyp(tabela_slow[i+1])='real' then d:='R';
                  if RozpoznajTyp(tabela_slow[i+1])='boolean' then d:='B';
               end else
               begin
                  z:=daj_index_zmiennej(tabela_slow[i+1]);
                  if z.nazwa='' then
                  begin
                     WstawBladDoTabeli(ile, 'Ta zmienna nie jest zadeklarowana "'+tabela_slow[i+1]+'"');
                  end else d:=z.typ;        // if d <> g
               end;
               if (RozpoznajTyp(tabela_slow[i+3])='integer') or (RozpoznajTyp(tabela_slow[i+3])='real')

                  or (RozpoznajTyp(tabela_slow[i+3])='boolean')then
               begin
                  if RozpoznajTyp(tabela_slow[i+3])='integer' then g:='I';
                  if RozpoznajTyp(tabela_slow[i+3])='real' then g:='R';
                  if RozpoznajTyp(tabela_slow[i+3])='boolean' then g:='B';
               end else
               begin
                  z:=daj_index_zmiennej(tabela_slow[i+3]);
                  if z.nazwa='' then
                  begin
                     WstawBladDoTabeli(ile,'Ta zmienna nie jest zadeklarowana "'+tabela_slow[i+3]+'"');
                  end else g:=z.typ;        // if d <> g
               end;
               case d of
               'B': if not (g=d) then
                       WstawBladDoTabeli(ile, 'Typy w tym wyraeniu s nie dopasowane "'+tabela_slow[i-1]+tabela_slow[i]+tabela_slow[i+1]+tabela_slow[i+2]+'"');

               'I': if not ((g='R') or (g='I')) then
                       WstawBladDoTabeli(ile, 'Typy w tym wyraeniu s nie dopasowane "'+tabela_slow[i-1]+tabela_slow[i]+tabela_slow[i+1]+tabela_slow[i+2]+'"');
               'R': if not ((g='R') or (g='I')) then
                       WstawBladDoTabeli(ile, 'Typy w tym wyraeniu s nie dopasowane "'+tabela_slow[i-1]+tabela_slow[i]+tabela_slow[i+1]+tabela_slow[i+2]+'"');
               end;
            end;
         end;
         inc(i);
      end;
      if ile=0 then Result:=false else Result:=true;
   end;

  
function TAnaliza.TworzZmienna(nz: String; typ: String; war: String): zmienna;
   var p: zmienna;
   begin
      p.nazwa:=nz;
      if typ='integer' then p.typ:='I';
      if typ='real' then p.typ:='R';
      if typ='boolean' then p.typ:='B';
      p.wartosc:=war;
      Result:= p;
   end;

  
function TAnaliza.RozpoznajTyp(war: String): String;
   var i: integer;
       wy: String;
       k: String;
   begin
      k:='';
      for i:=1 to length(war) do
      begin
      if war[i]='t' then
      begin
      if war[i+1]='r' then
      begin
      if war[i+2]='u' then
      begin
      if war[i+3]='e' then
      begin
      if war[i+4] in['a'..'z','+','/',':'..'~'] then
      begin
      k:='nic';
      end else begin wy:='boolean';break;end;
      end;
      end;
      end;
      end else
      if war[i]='f' then
      begin
      if war[i+1]='a' then
      begin
      if war[i+2]='l' then
      begin
      if war[i+3]='s' then
      begin
      if war[i+4]='e' then
      begin
      if war[i+5] in['a'..'z','+','/',':'..'~'] then
      begin
      k:='nic';
      end else begin wy:='boolean';break; end;
      end;
      end;
      end;
      end;
      end else
      if war[i]=',' then
         begin
                 wy:='real'; break;
         end else
      
      if war[i] in['-','0'..'9'] then
      begin
                  wy:='integer';
      end else k:='nic';

      end;
      if k='nic' then Result:='' else Result:=wy;
   end;

   
function TAnaliza.podziel_na_slowa(tekst: String): integer;
   var i,ile: integer;
       pom: String;
   begin
      kod:=tekst;
      pom:='';
      ile:=0;
      i:=1;
      while i<=length(tekst) do
      begin
         case tekst[i] of
         ' ': begin
                 if pom<>'' then
                 begin
                    setLength(tabela_slow,ile+1); //powieksza tab slow
                    tabela_slow[ile]:=pom;
                    inc(ile);
                    pom:='';
                 end;
                 repeat
                    inc(i);
                 until tekst[i]<>' ';
              end;
        '=','+','-','*','/',';',',','(',')','[',']':
              if not ((tekst[i-1] in ['+','-','*','/','=',' ']) and (tekst[i]='-') and (tekst[i+1] in ['0'..'9'])) then
              begin
                 if pom<>'' then
                 begin
                    setLength(tabela_slow,ile+1);
                    tabela_slow[ile]:=pom;
                    inc(ile);
                    pom:='';
                 end;
                 setLength(tabela_slow,ile+1);
                 tabela_slow[ile]:=tekst[i];
                 inc(ile);
                 inc(i);
              end else
              begin
                 pom:=pom+tekst[i];
                 inc(i);
              end;
         '.': begin
                 if (tekst[i-1]='d')  then
                 begin
                    setLength(tabela_slow,ile+1);
                    tabela_slow[ile]:=pom;
                    inc(ile);
                    pom:='';
                    setLength(tabela_slow,ile+1);
                    tabela_slow[ile]:=tekst[i];
                    inc(ile);
                    inc(i);
                 end else begin
                    if tekst[i-1] in ['0'..'9'] then
                    begin
                       repeat
                          if tekst[i]='.' then pom:=pom+','
                          else pom:=pom+tekst[i];
                          inc(i);
                       until tekst[i] in [';',' ','+','-','*','/'];
                       setLength(tabela_slow,ile+1);
                       tabela_slow[ile]:=pom;
                       inc(ile);
                       pom:='';
                    end;
                 end;
              end;
         #39: begin                             // ciapek   '
                 if pom<>'' then
                 begin
                    setLength(tabela_slow,ile+1);
                    tabela_slow[ile]:=pom;
                    inc(ile);
                    pom:='';
                 end;
                 repeat
                    pom:=pom+tekst[i];
                    inc(i);
                 until (tekst[i]=#39)  or (tekst[i]=#13);   // #13= Enter
                 if tekst[i]=#39 then begin pom:=pom+tekst[i]; inc(i); end;
                 setLength(tabela_slow,ile+1);
                 tabela_slow[ile]:=pom;
                 inc(ile);
                 pom:='';
              end;
         '{': begin
                 if pom<>'' then
                 begin
                    setLength(tabela_slow,ile+1);
                    tabela_slow[ile]:=pom;
                    inc(ile);
                    pom:='';
                 end;
                 repeat
                    inc(i);
                 until tekst[i]='}';
                 inc(i);
              end;
         #13: begin                 //enter
                if pom<>'' then
                begin
                   setLength(tabela_slow,ile+1);
                   tabela_slow[ile]:=pom;
                   inc(ile);
                   pom:='';
                end;
                setLength(tabela_slow,ile+1);
                tabela_slow[ile]:=tekst[i];
                inc(ile);
                inc(i);
                inc(i);
             end;
        ':','<','>': begin
                if pom<>'' then
                begin
                   setLength(tabela_slow,ile+1);
                   tabela_slow[ile]:=pom;
                   inc(ile);
                   pom := '';
                end;
                if (tekst[i+1]='=') or (tekst[i+1]='>') then
                begin
                   setLength(tabela_slow,ile+1);
                   tabela_slow[ile]:=tekst[i]+tekst[i+1];
                   inc(ile);
                   inc(i);
                   inc(i);
                end else begin
                   setLength(tabela_slow,ile+1);
                   tabela_slow[ile]:=tekst[i];
                   inc(ile);
                   inc(i);
                end;
              end;
         else begin
                 pom:=pom+tekst[i];
                 inc(i);
              end;
         end;
      end;
      Result:=ile;
   end;

function TAnaliza.tworz_zmienne(): integer;
   var i,ile,pom: integer;
   begin
      i:=0;
      ile:=length(tabela_zmiennych);
      while i<=length(tabela_slow)-1 do
      begin
         if tabela_slow[i]='var' then
         begin
            repeat
               if (tabela_slow[i]='integer')
                  or (tabela_slow[i]='real')

                  or (tabela_slow[i]='boolean')then
               begin
                  pom:=i;
                  i:=i-2;
                  setLength(tabela_zmiennych,ile+1);
                  tabela_zmiennych[ile]:=TworzZmienna(tabela_slow[i],tabela_slow[pom],'');
                  inc(ile);
                  dec(i);
                  while (tabela_slow[i]=',') or (tabela_slow[i]=#13) do
                  begin
                     if tabela_slow[i]=',' then
                     begin
                        dec(i);
                        setLength(tabela_zmiennych,ile+1);
                        tabela_zmiennych[ile]:=TworzZmienna(tabela_slow[i],tabela_slow[pom],'');
                        inc(ile);
                        dec(i);
                     end;
                     if tabela_slow[i]=#13 then
                     begin
                        dec(i);
                        if tabela_slow[i]=',' then
                        begin
                           dec(i);
                           setLength(tabela_zmiennych,ile+1);
                           tabela_zmiennych[ile]:=TworzZmienna(tabela_slow[i],tabela_slow[pom],'');
                           inc(ile);
                           dec(i);
                        end;
                     end;
                  end;
                  i:=pom+1;
               end else inc(i);
            until (tabela_slow[i]='begin')  or (tabela_slow[i]='var');
         end;
         if tabela_slow[i]<>'var' then inc(i);
      end;
      Result:=ile;
   end;
end.
