unit Executor;

interface

uses Windows, SysUtils, stdctrls, Analizator, Messages;

type

    TExecutor = class
    WypiszMemo: ^TMemo;
    private
       tabela_zmiennych: ^TZmienne;
       tabela_instrukcji: ^TTabS;
       brak_blad: boolean; 
       function jaki_typ(war: String): char;
       function wynik(oper: string; zm1: string; zm2: string; typ: char): String;
       function daj_index_zmiennej(zm: Variant): integer;
       function Usun_Ciapki(war: String): String;
       function wyr_arytmetyczne(operator: String; zm1: string; zm2: string; typ: char): String;
       function op_porownania(operator,zm1,zm2: string): boolean;
       function wynik_warunku(operator: String; typ1,typ2: char; war1,war2: String): boolean;
       function czy_spelniony_warunek(operator: string; zm1: string; zm2: string): boolean;
       procedure op_if(var i: integer; operator: string; zm1: string; zm2: string);
       procedure op_while(var i: integer; operator: string; zm1: string; zm2: string);
       procedure wypisanie_bledu(wypisz: String);
       procedure kon_while(var i: integer);
       procedure op_write(zm: String);
       procedure op_read(zm: String);
       procedure op_przypisania(zm: Variant; wartosc: Variant);
    public
       procedure Uruchom(wyp_memo: TMemo; tab_zm: TZmienne; tab_inst: TTabS);

    end;

var e: TExecutor;

implementation




    function TExecutor.Usun_Ciapki(war: String): String;
    var i: Integer;
       wy: string;  c:char;
    begin
       wy:='';  c:=#39;
       for i:=1 to length(war) do
       begin
          if war[i]<>c then wy:=wy+war[i];
       end;
       Result:= wy;
    end;


    procedure TExecutor.wypisanie_bledu(wypisz: String);
    begin
       WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
       WypiszMemo^.SelText:=wypisz;
       brak_blad:=false;
    end;


    function TExecutor.wynik_warunku(operator: String; typ1,typ2: char; war1,war2: String): boolean;
    begin
       case typ1 of
      
       'B': if typ2='B' then
            begin
               if operator='rowny' then
                  if war1=war2 then Result:=true else Result:=false;
               if operator='rozny' then
                  if war1<>war2 then Result:=true else Result:=false;
            end;
       'R','I': if (typ2='I') or (typ2='R') then
            begin
                if operator='mniejszy_rowny' then
                   if StrToFloat(war1)<=StrToFloat(war2) then Result:=true else Result:=false;
                if operator='rowny' then
                   if StrToFloat(war1)=StrToFloat(war2) then Result:=true else Result:=false;
                if operator='mniejszy' then
                   if StrToFloat(war1)<StrToFloat(war2) then Result:=true else Result:=false;
                if operator='wiekszy' then
                   if StrToFloat(war1)>StrToFloat(war2) then Result:=true else Result:=false;
                if operator='rozny' then
                   if StrToFloat(war1)<>StrToFloat(war2) then Result:=true else Result:=false;
                if operator='wiekszy_rowny' then
                   if StrToFloat(war1)>=StrToFloat(war2) then Result:=true else Result:=false;
            end;
       end;
    end;


 function TExecutor.op_porownania(operator,zm1,zm2: string): boolean;
    var pom,pom1: integer;
    begin

          pom:=daj_index_zmiennej(zm1);
          if pom<>-1 then
          begin

                pom1:=daj_index_zmiennej(zm2);
                if pom1<>-1 then
                begin
                   if (tabela_zmiennych^[pom].wartosc<>'') and (tabela_zmiennych^[pom1].wartosc<>'') then
                      Result:=wynik_warunku(operator, tabela_zmiennych^[pom].typ, tabela_zmiennych^[pom1].typ, tabela_zmiennych^[pom].wartosc, tabela_zmiennych^[pom1].wartosc)
                    else wypisanie_bledu(#13#10+'Jedna ze zmiennych jest pusta w warunku "'+zm1+'" lub "'+zm2+'" ');
                end else
                begin
                   if (tabela_zmiennych^[pom].wartosc<>'') and (zm2<>'') then
                      Result:=wynik_warunku(operator, tabela_zmiennych^[pom].typ, jaki_typ(zm2), tabela_zmiennych^[pom].wartosc, zm2)
                   else wypisanie_bledu(#13#10+'Jedna ze zmiennych jest pusta w warunku "'+zm1+'" lub "'+zm2+'" ');
                end;


          end else
          begin

                pom1:=daj_index_zmiennej(zm2);
                if pom1<>-1 then
                begin
                   if (tabela_zmiennych^[pom1].wartosc<>'') and (zm1<>'') then
                      Result:=wynik_warunku(operator, jaki_typ(zm1), tabela_zmiennych^[pom1].typ, zm1, tabela_zmiennych^[pom1].wartosc)
                   else wypisanie_bledu(#13#10+'Jedna ze zmiennych jest pusta w warunku "'+zm1+'" lub "'+zm2+'" ');
                end ;

          end;

    end;

   function TExecutor.wynik(oper: string; zm1: string; zm2: string; typ: char): String;
    begin
       if (zm1<>'') and (zm2<>'') then
       begin
          if oper='dodaj' then
          case typ of
             'R': Result:=FloatToStr(StrToFloat(zm1)+StrToFloat(zm2));
           
             'I': Result:=IntToStr(StrToInt(zm1)+StrToInt(zm2));
          end;
          if oper='odejmij' then
          case typ of
             'R': Result:=FloatToStr(StrToFloat(zm1)-StrToFloat(zm2));
             'I': Result:=IntToStr(StrToInt(zm1)-StrToInt(zm2));
          end;
          if oper='pomnoz' then
          case typ of
             'R': Result:=FloatToStr(StrToFloat(zm1)*StrToFloat(zm2));
             'I': Result:=IntToStr(StrToInt(zm1)*StrToInt(zm2));
          end;
          if oper='podziel' then
          case typ of
             'R': if StrToFloat(zm2)<>0 then
                     Result:=FloatToStr(StrToFloat(zm1)/StrToFloat(zm2))
                  else
                  begin
                     WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
                     WypiszMemo^.SelText:=#13#10+'Prba dzielenia przez zero';
                     brak_blad:=false;
                  end;
             'I': if StrToInt(zm2)<>0 then
                     Result:=IntToStr(Round(StrToInt(zm1)/StrToInt(zm2)))
                  else
                  begin
                     WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
                     WypiszMemo^.SelText:=#13#10+'Prba dzielenia przez zero';
                     brak_blad:=false;
                  end;
          end;
       end else
       begin
          brak_blad:=false;
          Result:='';
       end;
    end;

    function TExecutor.wyr_arytmetyczne(operator: String; zm1: string; zm2: string; typ: char): String;
    var pom,pom1: integer;
    begin

          pom:=daj_index_zmiennej(zm1);
          if pom<>-1 then
                begin
                pom1:=daj_index_zmiennej(zm2);
                if pom1<>-1 then Result:=wynik(operator, tabela_zmiennych^[pom].wartosc, tabela_zmiennych^[pom1].wartosc, typ)
                else Result:=wynik(operator, tabela_zmiennych^[pom].wartosc, zm2, typ);
                end
          else

             begin
                pom1:=daj_index_zmiennej(zm2);
                if pom1<>-1 then
                   Result:=wynik(operator, zm1, tabela_zmiennych^[pom1].wartosc, typ)
                  else Result:=wynik(operator, zm1, zm2, typ);
             end;

    end;


      function TExecutor.czy_spelniony_warunek(operator: string; zm1: string; zm2: string): boolean;
    begin
       if operator='rowny' then Result:=op_porownania(operator, zm1, zm2);
       if operator='mniejszy' then Result:=op_porownania(operator, zm1, zm2);
       if operator='wiekszy' then Result:=op_porownania(operator, zm1, zm2);
       if operator='wiekszy_rowny' then Result:=op_porownania(operator, zm1, zm2);
       if operator='mniejszy_rowny' then Result:=op_porownania(operator, zm1, zm2);
       if operator='rozny' then Result:=op_porownania(operator, zm1, zm2);

    end;


    procedure TExecutor.op_if(var i: integer; operator: string; zm1: string; zm2: string);
    var ile: integer;
    begin
       if not czy_spelniony_warunek(operator,zm1,zm2) then
       begin
          ile:=1;
          while ile<>0 do begin
             inc(i);
             if tabela_instrukcji^[i]='jesli' then inc(ile);
             if tabela_instrukcji^[i]='kon_jesli' then dec(ile);
          end;
       end;
    end;

   procedure TExecutor.Uruchom(wyp_memo: TMemo; tab_zm: TZmienne; tab_inst: TTabS);
    var i,pom: integer;
    begin
       tabela_zmiennych:=@tab_zm;
       tabela_instrukcji:=@tab_inst;

       WypiszMemo:=@wyp_memo;
       brak_blad:=true;
       while brak_blad and (i<length(tabela_instrukcji^)) do
       begin
          if tabela_instrukcji^[i]='podstaw' then
          begin
             if (tabela_instrukcji^[i+2]='dodaj') or (tabela_instrukcji^[i+2]='odejmij') or (tabela_instrukcji^[i+2]='pomnoz') or (tabela_instrukcji^[i+2]='podziel') then
             begin
                if tabela_instrukcji^[i+2]='dodaj' then

                begin
                   pom:=daj_index_zmiennej(tabela_instrukcji^[i+1]);
                   if pom<>-1 then op_przypisania(tabela_instrukcji^[i+1],wyr_arytmetyczne('dodaj',tabela_instrukcji^[i+3],tabela_instrukcji^[i+4],tabela_zmiennych^[pom].typ))
                   else WypiszMemo^.Lines.Append('Nie znalaz-em tej zmiennej "'+tabela_instrukcji^[i+1]+'"');
                end;
                if tabela_instrukcji^[i+2]='odejmij' then

                begin
                   pom:=daj_index_zmiennej(tabela_instrukcji^[i+1]);
                   if pom<>-1 then op_przypisania(tabela_instrukcji^[i+1],wyr_arytmetyczne('odejmij',tabela_instrukcji^[i+3],tabela_instrukcji^[i+4],tabela_zmiennych^[pom].typ))
                   else WypiszMemo^.Lines.Append('Nie znalaz-em tej zmiennej "'+tabela_instrukcji^[i+1]+'"');
                end;
                if tabela_instrukcji^[i+2]='pomnoz' then

                begin
                   pom:=daj_index_zmiennej(tabela_instrukcji^[i+1]);
                   if pom<>-1 then op_przypisania(tabela_instrukcji^[i+1],wyr_arytmetyczne('pomnoz',tabela_instrukcji^[i+3],tabela_instrukcji^[i+4],tabela_zmiennych^[pom].typ))
                   else WypiszMemo^.Lines.Append('Nie znalaz-em tej zmiennej "'+tabela_instrukcji^[i+1]+'"');
                end;
                if tabela_instrukcji^[i+2]='podziel' then

                begin
                   pom:=daj_index_zmiennej(tabela_instrukcji^[i+1]);
                   if pom<>-1 then op_przypisania(tabela_instrukcji^[i+1],wyr_arytmetyczne('podziel',tabela_instrukcji^[i+3],tabela_instrukcji^[i+4],tabela_zmiennych^[pom].typ))
                   else WypiszMemo^.Lines.Append('Nie znalaz-em tej zmiennej "'+tabela_instrukcji^[i+1]+'"');
                end;
             end else
                op_przypisania(tabela_instrukcji^[i+1],tabela_instrukcji^[i+2]);
          end;
          if tabela_instrukcji^[i]='wypiszln' then
          begin
             inc(i);
             while tabela_instrukcji^[i]<>'kon_wypiszln' do
             begin
                if tabela_instrukcji^[i]<>',' then op_write(tabela_instrukcji^[i]);
                inc(i);
             end;
             WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
             WypiszMemo^.SelText:=#13#10;
          end;
          if tabela_instrukcji^[i]='wypisz' then
          begin
             inc(i);
             while tabela_instrukcji^[i]<>'kon_wypisz' do
             begin
                if tabela_instrukcji^[i]<>',' then op_write(tabela_instrukcji^[i]);
                inc(i);
             end;
          end;
          if tabela_instrukcji^[i]='wczytaj' then
          begin
             WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
             WypiszMemo^.Perform(EM_SCROLLCARET, 0, 0);
             op_read(tabela_instrukcji^[i+1]);
          end;
          if tabela_instrukcji^[i]='wczytajln' then
          begin
             WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
             WypiszMemo^.Perform(EM_SCROLLCARET, 0, 0);
             op_read(tabela_instrukcji^[i+1]);
             WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
             WypiszMemo^.SelText:=#13#10;
          end;
          if tabela_instrukcji^[i]='jesli' then op_if(i, tabela_instrukcji^[i+1],tabela_instrukcji^[i+2],tabela_instrukcji^[i+3]);
          if tabela_instrukcji^[i]='kon_dopoki' then kon_while(i);
          if tabela_instrukcji^[i]='dopoki' then op_while(i, tabela_instrukcji^[i+1],tabela_instrukcji^[i+2],tabela_instrukcji^[i+3]);

          WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
          WypiszMemo^.Perform(EM_SCROLLCARET,0,0);
          inc(i);
       end;
    end;

      procedure TExecutor.op_while(var i: integer; operator: string; zm1: string; zm2: string);
    var ile: integer;
    begin
       if not czy_spelniony_warunek(operator,zm1,zm2) then
       begin
          ile:=1;
          while ile<>0 do begin
             inc(i);
             if tabela_instrukcji^[i]='dopoki' then inc(ile);
             if tabela_instrukcji^[i]='kon_dopoki' then dec(ile);
          end;
       end;
    end;


    procedure TExecutor.kon_while(var i: integer);
    begin
       while tabela_instrukcji^[i]<>'dopoki' do
       begin
          dec(i);
          if tabela_instrukcji^[i]='kon_dopoki' then kon_while(i);
       end;
       dec(i);
    end;


    
      function TExecutor.daj_index_zmiennej(zm: Variant): integer;
    var i,wy: integer;
    begin
       wy:=-1;
       for i:=0 to length(tabela_zmiennych^)-1 do
          if zm=tabela_zmiennych^[i].nazwa then
          begin
             wy:=i;
             break;
          end;
       Result:=wy;
    end;

   function TExecutor.jaki_typ(war: String): char;
   var i: integer;
       wy: char;
       k: String;
   begin
      k:=''; wy:=' ';
      for i:=1 to length(war) do
      begin
      if war[i]='t' then
      begin
      if war[i+1]='r' then
      begin
      if war[i+2]='u' then
      begin
      if war[i+3]='e' then
      begin
      if war[i+4] in['a'..'z','+','/',':'..'~'] then
      begin
      k:='nic';
      end else begin wy:='B';break;end;
      end;
      end;
      end;
      end else
      if war[i]='f' then
      begin
      if war[i+1]='a' then
      begin
      if war[i+2]='l' then
      begin
      if war[i+3]='s' then
      begin
      if war[i+4]='e' then
      begin
      if war[i+5] in['a'..'z','+','/',':'..'~'] then
      begin
      k:='nic';
      end else begin wy:='B';break; end;
      end;
      end;
      end;
      end;
      end else
      if war[i]='.' then
         begin
                 wy:='R'; break;
         end else

      if war[i] in['-','0'..'9'] then
      begin
                  wy:='I';
      end else k:='nic';

      end;
      if k='nic' then Result:=' ' else Result:=wy;
   end;

   procedure TExecutor.op_read(zm: String);
   var pom: integer;
       char: integer;
       wy: string;
       poms: string;
   begin
      poms:='';

          pom:=daj_index_zmiennej(zm);
          if pom<>-1 then
          begin
             while not (13=WypiszMemo^.tag) do
             begin
                char:=WypiszMemo^.tag;
                if chr(char) in [#8,' '..'~','','','','','','-','','','','','','','','','','','',''] then
                begin
                   if (char=8) and (length(poms)>0) then
                   begin
                      SetLength(poms,length(poms)-1);
                      wy:=WypiszMemo^.Text;
                      SetLength(wy,length(wy)-1);
                      WypiszMemo^.Text:=wy;
                      WypiszMemo^.tag:=255;
                      WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
                      WypiszMemo^.Perform(EM_SCROLLCARET,0,0);
                   end else
                   if char<>8 then
                   begin
                      poms:=poms+chr(char);
                      WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
                      WypiszMemo^.Perform(EM_SCROLLCARET,0,0);
                      WypiszMemo^.SelText:=chr(char);
                      WypiszMemo^.tag:=255;
                   end;
                   WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
                end;
             end;
             WypiszMemo^.Tag:=255;
          end;

             if tabela_zmiennych^[pom].typ='I' then
             if tabela_zmiennych^[pom].typ=jaki_typ(poms) then tabela_zmiennych^[pom].wartosc:=poms else
             begin
                WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
                WypiszMemo^.SelText:=#13#10+'Wystpi- b-d wczytywania pod zmienna "'+zm+'"';
                brak_blad:=false;
             end;
             if tabela_zmiennych^[pom].typ='R' then
             if ('R'=jaki_typ(poms)) or ('I'=jaki_typ(poms)) then
                tabela_zmiennych^[pom].wartosc:=poms else
             begin
                WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
                WypiszMemo^.SelText:=#13#10+'Wystpi- b-d wczytywania pod zmienna "'+zm+'"';
                brak_blad:=false;
            end;
   end;

     procedure TExecutor.op_write(zm: String);
    var pom: integer;
    begin

          pom:=daj_index_zmiennej(zm);
          if pom<>-1 then
          begin
             case tabela_zmiennych^[pom].typ of
             'R','I':if tabela_zmiennych^[pom].wartosc<>'' then
                     begin
                        WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
                        WypiszMemo^.SelText:=tabela_zmiennych^[pom].wartosc;
                     end else
                     begin
                        WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
                        WypiszMemo^.SelText:='0';
                     end;

             end;
          end else
          begin
             WypiszMemo^.SelStart:=length(WypiszMemo^.Text);
             WypiszMemo^.SelText:=Usun_Ciapki(zm);
          end;

    end;

    
    procedure TExecutor.op_przypisania(zm: Variant; wartosc: Variant);
    var pom,pom1: integer;
    begin
       if (zm<>'') and (wartosc<>'') then
       begin
          pom:=daj_index_zmiennej(zm);
          if pom<>-1 then
          begin
                pom1:=daj_index_zmiennej(wartosc);
                if pom1<>-1 then tabela_zmiennych^[pom].wartosc:=tabela_zmiennych^[pom1].wartosc
                else tabela_zmiennych^[pom].wartosc:=wartosc;

          end;
       end  else
       begin
          WypiszMemo^.Lines.Append('Pod zmienn "'+zm+'" podstawiana jest warto nie dopuszczalana. ');
          brak_blad:=false;
       end;
    end;


initialization
  e := TExecutor.Create;

end.

