unit Interpreter;

interface

uses
  Windows, Messages, SysUtils, Classes,  Forms, 
  ComCtrls, ImgList,  Analizator, StdCtrls, ToolWin, Dialogs, Controls;

type
  TForm1 = class(TForm)
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;

    ImageList1: TImageList;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    startuj: TToolButton;
    stopuj: TToolButton;
    Memo1: TMemo;
    Info1: TMemo;

    Edit: TMemo;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;

    procedure ActionZakonczExecute(Sender: TObject);
    procedure Otwieraj(sPlik: String);
    procedure ActionZapiszjakoExecute(Sender: TObject);
    procedure ActionZapiszExecute(Sender: TObject);
    procedure ActionOtworzExecute(Sender: TObject);
    procedure ActionNowyExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionStartExecute(Sender: TObject);
    procedure ActionZatrzymajExecute(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);


  private
     hThread:THANDLE ;

     function SprawdzCzyMaRozszerzenie(nz: String): String;
    { Private declarations }
  public
    Plikpas, Katalog: String;
    polj: TPoint;
    nowy: boolean;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ActionZakonczExecute(Sender: TObject);
begin
   close;
end;

procedure TForm1.Otwieraj(sPlik: String);
begin
   try
      Edit.Cursor:=crAppStart;
      if ExtractFileExt(sPlik)='.pas' then
      begin
         Form1.Caption:='Pascal-Int - '+ExtractFileName(sPlik);

         Form1.Plikpas:=ExtractFileName(sPlik);
         Katalog:=ExtractFileDir(sPlik);

      end;
       Edit.Visible:=true;
   except
      Application.MessageBox('Bd otwarcia pliku lub plikw.','Bd !!!',MB_OK);
   end;
end;

function TForm1.SprawdzCzyMaRozszerzenie(nz: String): String;
var i: integer;
    d: boolean;
    roz,naz: String;
begin
   roz:='';
   naz:='';
   d:=false;
   for i:=1 to length(nz) do
   begin
      if nz[i]='.' then d:=true;
      if not d then naz:=naz+nz[i]
      else roz:=roz+nz[i];
   end;
   if d then
      if AnsiLowerCase(roz)<>'pas' then Result:=naz+'.pas'
   else
      Result:=naz+'.pas';
end;

procedure TForm1.ActionZapiszjakoExecute(Sender: TObject);
begin
   if SaveDialog1.Execute then
   begin
      with SaveDialog1 do
      begin
         plikpas:=SprawdzCzyMaRozszerzenie(ExtractFileName(FileName));
         Edit.Lines.SaveToFile(plikpas);
         Edit.Modified:=false;
            Form1.Caption:='Pascal-Int - '+plikpas;
            Application.Title:='Pascal-Int - '+plikpas;
      end;
   end;
end;

procedure TForm1.ActionZapiszExecute(Sender: TObject);
begin
   if plikpas='' then
   begin
      ActionZapiszjakoExecute(Sender);
   end else
   begin
      Edit.Lines.SaveToFile(Katalog+'\'+plikpas);
      Edit.Modified:=false;
   end;
end;



procedure TForm1.ActionOtworzExecute(Sender: TObject);
var dwExitCode:DWORD;
begin
   dwExitCode:=11;
   TerminateThread(hThread,dwExitCode);
   if OpenDialog1.Execute then
   with OpenDialog1 do
   try
      Edit.Cursor:=crAppStart;
      if ExtractFileExt(FileName)='.pas' then
      begin
          Form1.Caption:='Pascal-Int - '+ExtractFileName(FileName);


         Plikpas:=ExtractFileName(FileName);
         Katalog:=ExtractFileDir(FileName);
         Edit.Lines.LoadFromFile(Katalog+'\'+Plikpas);
      end;
       Edit.Visible:=true;
       Edit.Modified:=false;
       Memo1.Clear;
       Info1.Clear;
   except
      Application.MessageBox('Bd otwarcia pliku.','Bd !!!',MB_OK);
   end;
end;

procedure TForm1.ActionNowyExecute(Sender: TObject);
begin
   nowy:=true;
   plikpas:='';
   Edit.Lines.Clear;
   Form1.Caption:='Pascal-Int - Nowy.pas';
   Memo1.Clear;
   Info1.Clear;
  end;




procedure TForm1.FormCreate(Sender: TObject);


begin
   nowy:=true;
   Edit.Clear;
   Info1.Clear;
  
         Form1.Caption:='Pascal-Int - Nowy.pas';

   Info1.Lines.Append('Pascal-Int - Prosty Interpreter Pascala');
   Info1.Lines.Append('Licencja GNU General Public Licence');
   Info1.Lines.Append('Autorzy:Hanna Borkowska, Michal Korzeniowski');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var dwExitCode:DWORD;
begin
   dwExitCode:=11;
   TerminateThread(hThread,dwExitCode);
   if Edit.Modified then
   begin
      if Application.MessageBox('Czy chcesz zapisac zmiany?','Zapisz plik',MB_YESNO) = IDYES then
      if OpenDialog1.FileName<>'' then
      begin
         try
            Form1.Caption:='Zapisalem...';
            Edit.Lines.SaveToFile(Katalog+'\'+Plikpas);
         except
            on E: Exception do ShowMessage(E.Message);
         end;
      end else ActionZapiszjakoExecute(Sender);
   end;
end;

procedure Start;
var
    t: TAnaliza;
begin
   Application.ProcessMessages;
   if Form1.Edit.Lines.Text<>'' then
   begin
      Form1.Memo1.Lines.Clear;
      Form1.Memo1.tag:=255;
      Form1.Info1.Clear;
   
      t:=TAnaliza.Create();
      t.Analizuj(Form1.Memo1,Form1.Edit.Lines, Form1.Info1);
   end
end;





procedure TForm1.ActionStartExecute(Sender: TObject);
var dwThreadId:DWORD;
    dwExitCode:DWORD;
begin
   dwExitCode:=11;
   TerminateThread(hThread,dwExitCode);
   Memo1.SetFocus;
   hThread:=CreateThread(nil,0,@Start,nil,0,dwThreadId);
end;




procedure TForm1.ActionZatrzymajExecute(Sender: TObject);
var dwExitCode:DWORD;
   
begin
   dwExitCode:=11;
   TerminateThread(hThread,dwExitCode);
  
end;



procedure TForm1.ToolButton6Click(Sender: TObject);
begin
Close();
end;




procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
   Memo1.tag:=ord(key);
   sleep(50);
   Memo1.SelStart:=length(Memo1.Text);
   Memo1.perform(EM_SCROLLCARET, 0,0);
end;

end.

